#include <Adafruit_SSD1306.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>
#include <Adafruit_GFX.h>
#include <Wire.h>
#include <RTClib.h>
#include <stdlib.h>
////////////////////////////
const int buttonPin2 = 2;
const int buttonPin3 = 3;
const int buttonPin4 = 4;
const int ledPin = 7; 
const int oneWireBusPin = 8;

int buttonState2 = HIGH;
int buttonState3 = HIGH;
int buttonState4 = HIGH;

int lastButtonState2 = HIGH;
int lastButtonState3 = HIGH;
int lastButtonState4 = HIGH;

const int debounceDelay = 50;
//////////////////////////////////////
#define SCREEN_WIDTH 128  
#define SCREEN_HEIGHT 64  
#define TRIG_PIN 5
#define ECHO_PIN 6
//////////////////////////////////////

#define PADDLE_WIDTH 3
#define PADDLE_HEIGHT 18
#define BALL_SIZE 2
#define PADDLE_SPEED 1
#define BALL_SPEED 1.8

///////////////////////////////


int menu = 0;
int menuTimer = 0; 
bool showPage = false; 
int tl = 1;
int korekce = 32;
int korekce_temp = 2;
int playerY, computerY;
float ballX, ballY;
float ballSpeedX, ballSpeedY;
int playerScore, computerScore;
boolean buzzerOn = false;

#define BMP280_ADRESA (0x76)
Adafruit_SSD1306 displej(128, 64, &Wire, -1);
RTC_DS3231 rtc;
Adafruit_BMP280 bmp;
////////////////////////////////////////////////////////////

void setup() {
  pinMode(TRIG_PIN, OUTPUT);
  pinMode(ECHO_PIN, INPUT);
  Wire.begin();
  rtc.begin();
  Serial.begin(9600);
  pinMode(buttonPin2, INPUT);
  pinMode(buttonPin3, INPUT);
  pinMode(buttonPin4, INPUT);
  pinMode(ledPin, OUTPUT);
  digitalWrite(buttonPin2, HIGH);
  digitalWrite(buttonPin3, HIGH);
  digitalWrite(buttonPin4, HIGH);
  displej.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  displej.clearDisplay();
  displej.setTextColor(WHITE);
  displej.setTextSize(2);

  displej.clearDisplay();
  displej.setCursor(32, 20);
  displej.print("ANURA");
  displej.display();

  delay(2000);

  displej.clearDisplay();
  displej.setCursor(22, 20);
  displej.print("Welcome");
  displej.display();

  delay(1500);

  displej.clearDisplay();
  displej.display();
  if (!bmp.begin(BMP280_ADRESA)) {
    Serial.println("error");
    while (1)
      ;
  }
  bmp.setSampling(Adafruit_BMP280::MODE_NORMAL,
                  Adafruit_BMP280::SAMPLING_X2,
                  Adafruit_BMP280::SAMPLING_X16,
                  Adafruit_BMP280::FILTER_X16,
                  Adafruit_BMP280::STANDBY_MS_500);

  playerY = SCREEN_HEIGHT / 2 - PADDLE_HEIGHT / 2;
  computerY = SCREEN_HEIGHT / 2 - PADDLE_HEIGHT / 2;
  ballX = SCREEN_WIDTH / 2;
  ballY = SCREEN_HEIGHT / 2;

  randomSeed(analogRead(A0));
  int directionX = random(2);
  int directionY = random(2);
  ballSpeedX = BALL_SPEED * (directionX == 0 ? -1 : 1);
  ballSpeedY = BALL_SPEED * (directionY == 0 ? -1 : 1);

  playerScore = 0;
  computerScore = 0;
}
void loop() {


  DateTime now = rtc.now();

  int hour = now.hour();
  int minute = now.minute();
  int year = now.year();
  int month = now.month();
  int day = now.day();

  if (menuTimer == 0) menuTimer = millis();
  if ((millis() - menuTimer) >= 1) {
    menuTimer = 0;
  }
  //keyboard
  int reading2 = digitalRead(buttonPin2);
  int reading3 = digitalRead(buttonPin3);
  int reading4 = digitalRead(buttonPin4);

  if (reading2 != lastButtonState2) {
    lastButtonState2 = reading2;
    delay(debounceDelay);

    if (reading2 != buttonState2) {
      buttonState2 = reading2;

      if (buttonState2 == LOW) {
        if(menu==1)toggleLED();
        if(menu==5){
          displej.clearDisplay();
          displej.fillRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, WHITE);
          displej.display();
          delay(500);
        }
      }
    }
  }

  if (reading3 != lastButtonState3) {
    lastButtonState3 = reading3;
    delay(debounceDelay);

    if (reading3 != buttonState3) {
      buttonState3 = reading3;

      if (buttonState3 == LOW) {
        menu++;
        if (menu == 6) menu = 1;
      }
    }
  }

  if (reading4 != lastButtonState4) {
    lastButtonState4 = reading4;
    delay(debounceDelay);

    if (reading4 != buttonState4) {
      buttonState4 = reading4;

      if (buttonState4 == LOW) {
      }
    }
  }
  ////////////menu
  if (menu == 1 && (tl == 1 || menuTimer == 0)) {
    showPage = false;
    displej.clearDisplay();
    displej.setTextSize(3);
    displej.setCursor(20, 10);
    if(hour<10) displej.print("0");
    displej.print(hour);
    displej.print(":");
    if (minute < 10) {
      displej.print("0"); 
    }
    displej.print(minute);
    displej.setTextSize(2);
    if(month > 9) displej.setCursor(5, 45);
    else displej.setCursor(10, 45);
    if(day<10) displej.print("0");
    displej.print(day);
    displej.print("/");
    displej.print(month);
    displej.print("/");
    displej.print(year);
    displej.display();
    tl = 0;
  }
  if (menu == 2 && (tl == 0 || menuTimer == 0)) {
    showPage = false;
    displej.clearDisplay();
    displej.setTextSize(3);
    displej.setCursor(2, 7);
    displej.print(bmp.readTemperature() - korekce_temp);
    displej.print(" C");
    displej.setTextSize(2);
    displej.setCursor(4, 45);
    displej.print(bmp.readPressure() / 100.00 + korekce);
    displej.print("hpa");
    displej.display();
    tl = 1;
  }
  if (menu == 3 && (tl == 1 || menuTimer == 0)) {
    showPage = false;
    displej.setTextSize(1);
    displej.clearDisplay();
    displej.setCursor(25, 0);
    displej.print("Range-Finder");
    displej.drawLine(0, 12, 128, 12, WHITE);
    digitalWrite(TRIG_PIN, LOW);
    delayMicroseconds(2);
    digitalWrite(TRIG_PIN, HIGH);
    delayMicroseconds(10);
    digitalWrite(TRIG_PIN, LOW);

    long duration = pulseIn(ECHO_PIN, HIGH);
    int distance = duration * 0.034 / 2; 
    if(distance>1000) distance=0;
    if(distance>99) displej.setCursor(10,28);
    else displej.setCursor(25,28);
    displej.setTextSize(3);
    displej.print(distance);
    displej.print(" cm");
    displej.display();
    tl = 0;
  }
  if (menu == 4 && (tl == 0 || menuTimer == 0)) {
    showPage = false;


    displej.clearDisplay();

    updatePlayer();
    updateComputerAI();
    updateBall();

    drawPaddle(0, playerY);
    drawPaddle(SCREEN_WIDTH - PADDLE_WIDTH, computerY);
    drawBall(ballX, ballY);

    displayScores();

    displej.display();

    if (buttonState2 == HIGH && buttonState4 == HIGH){
      playerScore = 0;
      computerScore = 0;
      resetBall(); 
    }
      tl = 1;
  }
  if (menu == 5 && (tl == 1 || menuTimer == 0)) {
    showPage = false;
    displej.setTextSize(1);
    displej.clearDisplay();
    displej.setCursor(23, 0);
    displej.print("Device control");
    displej.drawLine(0, 12, 128, 12, WHITE);
    displej.setCursor(5, 15);
    displej.print("RTC temp. ");
    displej.print(rtc.getTemperature());
    displej.print("C");
    displej.display();
    tl=1;
  }
}

void drawPaddle(int x, int y) {
  displej.fillRect(x, y, PADDLE_WIDTH, PADDLE_HEIGHT, SSD1306_WHITE);
}

void drawBall(int x, int y) {
  displej.fillCircle(x, y, BALL_SIZE, SSD1306_WHITE);
}

void updateBall() {
  ballX += ballSpeedX;
  ballY += ballSpeedY;

  if (ballY <= 0 || ballY >= SCREEN_HEIGHT - BALL_SIZE) {
    ballSpeedY = -ballSpeedY;
  }

  if (ballX <= PADDLE_WIDTH && ballY >= playerY && ballY <= playerY + PADDLE_HEIGHT) {
    ballSpeedX = -ballSpeedX;
  }
  if (ballX >= SCREEN_WIDTH - PADDLE_WIDTH - BALL_SIZE && ballY >= computerY && ballY <= computerY + PADDLE_HEIGHT) {
    ballSpeedX = -ballSpeedX;
  }

  if (ballX <= 0) {
    computerScore++;
    resetBall();
  }
  if (ballX >= SCREEN_WIDTH - BALL_SIZE) {
    playerScore++;
    resetBall();
  }
}

void resetBall() {
  ballX = SCREEN_WIDTH / 2;
  ballY = SCREEN_HEIGHT / 2;

  int directionX = random(2);
  int directionY = random(2);
  ballSpeedX = BALL_SPEED * (directionX == 0 ? -1 : 1);
  ballSpeedY = BALL_SPEED * (directionY == 0 ? -1 : 1);
}

void updateComputerAI() {
  if (computerY + PADDLE_HEIGHT / 2 < ballY) {
    computerY += PADDLE_SPEED;
  }
  if (computerY + PADDLE_HEIGHT / 2 > ballY) {
    computerY -= PADDLE_SPEED;
  }

  if (computerY < 0) {
    computerY = 0;
  }
  if (computerY > SCREEN_HEIGHT - PADDLE_HEIGHT) {
    computerY = SCREEN_HEIGHT - PADDLE_HEIGHT;
  }
}

void updatePlayer() {
  if (digitalRead(buttonPin4) == LOW && playerY > 0) {
    playerY -= PADDLE_SPEED;
  }
  if (digitalRead(buttonPin2) == LOW && playerY < SCREEN_HEIGHT - PADDLE_HEIGHT) {
    playerY += PADDLE_SPEED;
  }
}


void displayScores() {
  displej.setTextSize(1);
  displej.setTextColor(SSD1306_WHITE);
  displej.setCursor(SCREEN_WIDTH / 2 - 10, 0);
  displej.print(playerScore);
  displej.print(" - ");
  displej.print(computerScore);
}
void toggleLED() {
  if (digitalRead(ledPin) == LOW) {
    digitalWrite(ledPin, HIGH);
  } else {
    digitalWrite(ledPin, LOW);
  }
}